# std::tr1::poisson_distribution< _IntType, _RealType > Class Template Reference
[Discrete Distributions]

List of all members.

## Detailed Description

### template<typename _IntType = int, typename _RealType = double>
class std::tr1::poisson_distribution< _IntType, _RealType >

The formula for the poisson probability mass function is where is the parameter of the distribution.

Definition at line 1829 of file random.

## Public Types

- typedef _RealType input_type
- typedef _IntType result_type

## Public Member Functions

- _RealType mean () const
- template<class _UniformRandomNumberGenerator> result_type operator() (_UniformRandomNumberGenerator &__urng)
- poisson_distribution (const _RealType &__mean=_RealType(1))
- void reset ()

## Friends

- template<typename _IntType1, typename _RealType1, typename _CharT, typename _Traits> std::basic_ostream< _CharT,
  _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > &__os, const poisson_distribution< _IntType1, _RealType1 > &__x)
- template<typename _IntType1, typename _RealType1, typename _CharT, typename _Traits> std::basic_istream< _CharT,
  _Traits > & operator>> (std::basic_istream< _CharT, _Traits > &__is, poisson_distribution< _IntType1, _RealType1 > &__x)

## Member Function Documentation

template<typename _IntType = int, typename _RealType = double>

_RealType std::tr1::poisson_distribution< _IntType, _RealType >::mean | ( |  | ) | const`[inline]`

Gets the distribution parameter `mean`.

Definition at line 1849 of file random.

template<typename _IntType, typename _RealType>
template<class _UniformRandomNumberGenerator>

poisson_distribution< _IntType, _RealType >::result_type std::tr1::poisson_distribution< _IntType, _RealType >::operator() | ( | _UniformRandomNumberGenerator & | __urng | ) |

A rejection algorithm when mean >= 12 and a simple method based upon the multiplication of uniform random variates otherwise. NB: The former is available only if _GLIBCXX_USE_C99_MATH_TR1 is defined.

Reference: Devroye, L. "Non-Uniform Random Variates Generation." Springer-Verlag, New York, 1986, Ch. X, Sects. 3.3 & 3.4 (+ Errata!).

Definition at line 906 of file random.tcc.

References std::abs(), std::ceil(), std::numeric_limits< _Tp >::epsilon(), std::floor(), std::log(), and std::numeric_limits< _Tp >::max().

## Friends And Related Function Documentation

template<typename _IntType = int, typename _RealType = double>
template<typename _IntType1, typename _RealType1, typename _CharT, typename _Traits>

std::basic_ostream<_CharT, _Traits>& operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const poisson_distribution< _IntType1, _RealType1 > & | __x |
| ) |  |  | `[friend]`

Inserts a poisson_distribution random number distribution `__x` into the output stream `__os`.

Parameters:

  | __os | An output stream.
  | __x | A poisson_distribution random number distribution.

Returns:
  The output stream with the state of `__x` inserted or in an error state.

template<typename _IntType = int, typename _RealType = double>
template<typename _IntType1, typename _RealType1, typename _CharT, typename _Traits>

std::basic_istream<_CharT, _Traits>& operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | poisson_distribution< _IntType1, _RealType1 > & | __x |
| ) |  |  | `[friend]`

Extracts a poisson_distribution random number distribution `__x` from the input stream `__is`.

Parameters:

  | __is | An input stream.
  | __x | A poisson_distribution random number generator engine.

Returns:
  The input stream with `__x` extracted or in an error state.

The documentation for this class was generated from the following files:

- random
- random.tcc